---
title: Clipboard.writeText()
slug: Web/API/Clipboard/writeText
tags:
  - API
  - Clip
  - Clipboard
  - Clipboard API
  - Cut
  - Method
  - Pasteboard
  - Reference
  - Scrap
  - copy
  - paste
  - writeText
---
<div>{{APIRef("Clipboard API")}}</div>

<p>The {{domxref("Clipboard")}} interface's <strong><code>writeText()</code></strong> property writes the specified text string to the system clipboard. Text may be read back using either {{domxref("Clipboard.read", "read()")}} or {{domxref("Clipboard.readText", "readText()")}}.</p>

<p>The <code>"clipboard-write"</code> permission of the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a>, is granted automatically to pages when they are in the active tab.</p>

<div class="note">
<p><strong>Note:</strong> Browser support for the asynchronous clipboard APIs is still in the process of being implemented. Be sure to check the {{anch("Browser compatibility", "compatibility table")}} as well as {{SectionOnPage("/en-US/docs/Web/API/Clipboard", "Clipboard availability")}} for more information.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>promise</em> = navigator.clipboard.writeText(<em>newClipText</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>newClipText</code></dt>
 <dd>The {{domxref("DOMString")}} to be written to the clipboard.</dd>
 <dt>
 <h3 id="Return_value">Return value</h3>
 </dt>
</dl>

<p>A {{jsxref("Promise")}} which is resolved once the clipboard's contents have been updated. The promise is rejected if the caller does not have permission to write to the clipboard.</p>

<h2 id="Example">Example</h2>

<p>This example sets the clipboard's contents to the string "&lt;empty clipboard&gt;".</p>

<pre class="brush: js notranslate">navigator.clipboard.writeText("&lt;empty clipboard&gt;").then(function() {
  /* clipboard successfully set */
}, function() {
  /* clipboard write failed */
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Clipboard API','#dom-clipboard-writetext','writeText()')}}</td>
   <td>{{Spec2('Clipboard API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Clipboard.writeText")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Clipboard_API">Clipboard API</a></li>
 <li><a href="https://async-clipboard-api.glitch.me/">Async Clipboard API demo on Glitch</a></li>
 <li><a href="https://web.dev/image-support-for-async-clipboard/">Image support for Async Clipboard article</a></li>
</ul>
